org.apache.lucene.analysis

## Class MockAnalyzer

- java.lang.Object
- - org.apache.lucene.analysis.Analyzer
  - - org.apache.lucene.analysis.MockAnalyzer

All Implemented Interfaces:
  Closeable, AutoCloseable

    public final class MockAnalyzer
    extends Analyzer

Analyzer for testing

This analyzer is a replacement for Whitespace/Simple/KeywordAnalyzers for unit tests. If you are testing a custom component such as a queryparser or analyzer-wrapper that consumes analysis streams, its a great idea to test it with this analyzer instead. MockAnalyzer has the following behavior:

- By default, the assertions in `MockTokenizer` are turned on for extra checks that the consumer is consuming properly. These checks can be disabled with `setEnableChecks(boolean)`.
- Payload data is randomly injected into the stream for more thorough testing of payloads.

See Also:
  `MockTokenizer`

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.lucene.analysis.Analyzer

`Analyzer.GlobalReuseStrategy, Analyzer.PerFieldReuseStrategy, Analyzer.ReuseStrategy, Analyzer.TokenStreamComponents`

### Constructor Summary

Constructors
Constructor and Description
`MockAnalyzer(Random random)` Create a Whitespace-lowercasing analyzer with no stopwords removal.
`MockAnalyzer(Random random, CharacterRunAutomaton runAutomaton, boolean lowerCase)` Calls `MockAnalyzer(random, runAutomaton, lowerCase, MockTokenFilter.EMPTY_STOPSET, false`).
`MockAnalyzer(Random random, CharacterRunAutomaton runAutomaton, boolean lowerCase, CharacterRunAutomaton filter, boolean enablePositionIncrements)` Creates a new MockAnalyzer.

### Method Summary

Methods
`Analyzer.TokenStreamComponents` `createComponents(String fieldName, Reader reader)`
`int` `getPositionIncrementGap(String fieldName)`
`void` `setEnableChecks(boolean enableChecks)` Toggle consumer workflow checking: if your test consumes tokenstreams normally you should leave this enabled.
`void` `setMaxTokenLength(int length)` Toggle maxTokenLength for MockTokenizer
`void` `setPositionIncrementGap(int positionIncrementGap)`

### Methods inherited from class org.apache.lucene.analysis.Analyzer

`close, getOffsetGap, initReader, tokenStream`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### MockAnalyzer

    public MockAnalyzer(Random random,
                CharacterRunAutomaton runAutomaton,
                boolean lowerCase,
                CharacterRunAutomaton filter,
                boolean enablePositionIncrements)

Creates a new MockAnalyzer.

Parameters:
  `random` - Random for payloads behavior
  `runAutomaton` - DFA describing how tokenization should happen (e.g. [a-zA-Z]+)
  `lowerCase` - true if the tokenizer should lowercase terms
  `filter` - DFA describing how terms should be filtered (set of stopwords, etc)
  `enablePositionIncrements` - true if position increments should reflect filtered terms.

#### MockAnalyzer

    public MockAnalyzer(Random random,
                CharacterRunAutomaton runAutomaton,
                boolean lowerCase)

Calls `MockAnalyzer(random, runAutomaton, lowerCase, MockTokenFilter.EMPTY_STOPSET, false`).

#### MockAnalyzer

    public MockAnalyzer(Random random)

Create a Whitespace-lowercasing analyzer with no stopwords removal.

Calls `MockAnalyzer(random, MockTokenizer.WHITESPACE, true, MockTokenFilter.EMPTY_STOPSET, false`).

### Method Detail

#### createComponents

    public Analyzer.TokenStreamComponents createComponents(String fieldName,
                                                  Reader reader)

Specified by:
  `createComponents` in class `Analyzer`

#### setPositionIncrementGap

    public void setPositionIncrementGap(int positionIncrementGap)

#### getPositionIncrementGap

    public int getPositionIncrementGap(String fieldName)

Overrides:
  `getPositionIncrementGap` in class `Analyzer`

#### setEnableChecks

    public void setEnableChecks(boolean enableChecks)

Toggle consumer workflow checking: if your test consumes tokenstreams normally you should leave this enabled.

#### setMaxTokenLength

    public void setMaxTokenLength(int length)

Toggle maxTokenLength for MockTokenizer